void checkPass();
void changePass();
void goToChangePass();
//PORTA F0 F1 F2 output for KeyPad
//PORTA F3 output signal
//PORTB F0 F1 F2 F3 input for KeyPad
//PORTB F7 output for start change pass
//PORTB F4 does not change pass
//PORTB F5 change Pass correctely
//PORTB F6 chip is locked
//EEPROM 0 contain first 2 digit of pass
//EEPROM 1 contain second 2 digit of pass
//EEPROM 3 contain if the lock is locked
//EEPROM 4 contain the number of wrong pass
//* for change pass after enter the now one
//# to end change pass
void main(){
     short x;
     TRISA = 0;
     TRISB = 0x0f;
     //TRISB = 0x0;
     PORTA = 0;
     PORTB = 0;
     //if(EEprom_read(2u)==0xff){
               //EEprom_Write(0u, 0x12);
               //EEprom_Write(1u, 0x34);
               EEprom_write(5u,1);
               EEprom_write(6u,2);
               EEprom_write(7u,3);
               EEprom_write(8u,4);
               EEprom_write(2u,1);
               EEprom_write(3u,1);
               Delay_ms(30);
     //}
     x=EEprom_read(3u);
//     x=EEprom_read(0u);
     //PORTB=x;
     if(x==0){
             PORTB.F6=1;
             while(1);
     }
     else
         checkPass();


}
void checkPass(){

    short digit=-1,digitNumber=0,errorNumber=0;
    unsigned char data1,data2,data3,data4;
    while(1) {
              PORTA.F0 = 1;
              PORTA.F1 = 0;
              PORTA.F2 = 0;
              
              if (PORTB.F0 == 1) digit = 1;
              if (PORTB.F1 == 1) digit = 4;
              if (PORTB.F2 == 1) digit = 7;
              if (PORTB.F3 == 1) digit = -1;

              PORTA.F0 = 0;
              PORTA.F1 = 1;
              PORTA.F2 = 0;

              if (PORTB.F0 == 1) digit = 2;
              if (PORTB.F1 == 1) digit = 5;
              if (PORTB.F2 == 1) digit = 8;
              if (PORTB.F3 == 1) digit = 0;

              PORTA.F0 = 0;
              PORTA.F1 = 0;
              PORTA.F2 = 1;

              if (PORTB.F0 == 1) digit = 3;
              if (PORTB.F1 == 1) digit = 6;
              if (PORTB.F2 == 1) digit = 9;
              if (PORTB.F3 == 1) digit = 10;//start this trial from begin


              if (digit != -1) {
                 digitNumber++;
                 if(digit==10){
                      digitNumber=0;
                 }
                 if(digitNumber==1){
                      data1 = digit ;
                      PORTB.F4=0;
                      //PORTA.F4=0;
                      PORTB.F7=0;
                      PORTB.F5=0;
                      //PORTB.F7=1;
                 }
                 else if(digitNumber==2){
                  data2 = digit ;
                  //PORTB.F7=0;
                 }
                 else if(digitNumber==3){
                  data3 = digit ;
                  //PORTB.F7=1;
                  }
                 else if(digitNumber==4){
                      data4 = digit ;
                      //PORTB.F7=0;
                      if(EEprom_read(5u)==data1&&EEprom_read(6u)==data2&&
                      EEprom_read(7u)==data3&&EEprom_read(8u)==data4){
                            PORTA.F3=1;
                            errorNumber=0;
                            EEprom_write(4u,errorNumber);
                            goToChangePass();
                      }
                      else{
                           //PORTB.F7=1;
                           errorNumber=EEprom_read(4u);
                           errorNumber++;
                           EEprom_write(4u,errorNumber);
                           if(errorNumber==3){
                                    EEprom_write(3u,0);
                                    PORTB.F6=1;
                                    while(1);
                           }
                      }
                      digitNumber=0;
                 }
                 digit=-1;
                 Delay_ms(500);
                 //PORTB.F7=0;
              }
     }
}
void goToChangePass(){
    short digit=-1;
    short data1,data2;
    int afterSecond=50000;
     PORTA.F0 = 1;
     PORTA.F1 = 0;
     PORTA.F2 = 0;
     for(;afterSecond<0;afterSecond-=10){
            Delay_ms(10);
            if (PORTB.F3 == 1){
                digit = 0;
                //PORTA.F4=1;
                PORTB.F7=1;
                PORTA.F3=0;
                Delay_ms(500);
                changePass();
                return;
            }
     }
     PORTA.F3=0;//after one second
}
void changePass(){
    short digit=-1,digitNumber=0;
    unsigned char data1,data2,data3,data4;
    while(1) {

              PORTA.F0 = 1;
              PORTA.F1 = 0;
              PORTA.F2 = 0;

              if (PORTB.F0 == 1) digit = 1;
              if (PORTB.F1 == 1) digit = 4;
              if (PORTB.F2 == 1) digit = 7;
              if (PORTB.F3 == 1) digit = -1;

              PORTA.F0 = 0;
              PORTA.F1 = 1;
              PORTA.F2 = 0;

              if (PORTB.F0 == 1) digit = 2;
              if (PORTB.F1 == 1) digit = 5;
              if (PORTB.F2 == 1) digit = 8;
              if (PORTB.F3 == 1) digit = 0;


              PORTA.F0 = 0;
              PORTA.F1 = 0;
              PORTA.F2 = 1;

              if (PORTB.F0 == 1) digit = 3;
              if (PORTB.F1 == 1) digit = 6;
              if (PORTB.F2 == 1) digit = 9;
              if (PORTB.F3 == 1) digit = 10;//end change pass


              if (digit != -1) {
                 digitNumber++;
                 if(digit==10){
                      PORTB.F4=1;
                      //PORTA.F4=0;
                      PORTB.F7=0;
                      return;
                 }
                 if(digitNumber==1) data1 = digit ;
                 else if(digitNumber==2) data2 = digit ;
                 else if(digitNumber==3) data3 = digit ;
                 else if(digitNumber==4){
                      data4 = digit ;
                      EEprom_write(5u,data1);
                      EEprom_write(6u,data2);
                      EEprom_write(7u,data3);
                      EEprom_write(8u,data4);
                      //PORTA.F4=0;
                      PORTB.F7=0;
                      PORTB.F5=1;
                      return;
                 }
                 digit=-1;
                 Delay_ms(500);
              }
     }
}